__gnu_debug::basic_string< _CharT, _Traits, _Allocator > Class Template Reference
Inheritance diagram for __gnu_debug::basic_string< _CharT, _Traits, _Allocator >:
[legend]

## Public Types

typedef _Allocator | allocator_type
typedef __gnu_debug::_Safe_iterator< typename _Base::const_iterator, basic_string > | const_iterator
typedef _Base::const_pointer | const_pointer
typedef _Base::const_reference | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef _Base::difference_type | difference_type
typedef __gnu_debug::_Safe_iterator< typename _Base::iterator, basic_string > | iterator
typedef _Base::pointer | pointer
typedef _Base::reference | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef _Base::size_type | size_type
typedef _Traits | traits_type
typedef _Traits::char_type | value_type

## Public Member Functions

| basic_string (_Base &&__base) noexcept
template<typename _InputIterator >
| basic_string (_InputIterator __begin, _InputIterator __end, const _Allocator &__a=_Allocator())
| basic_string (basic_string &&)=default
| basic_string (basic_string &&__s, const _Allocator &__a) noexcept(std::is_nothrow_constructible< _Base, _Base, const _Allocator & >::value)
| basic_string (const _Allocator &__a) noexcept
| basic_string (const _Base &__base)
| basic_string (const _CharT *__s, const _Allocator &__a=_Allocator())
| basic_string (const _CharT *__s, size_type __n, const _Allocator &__a=_Allocator())
| basic_string (const basic_string &)=default
| basic_string (const basic_string &__s, const _Allocator &__a)
| basic_string (const basic_string &__str, size_type __pos, size_type __n=_Base::npos, const _Allocator &__a=_Allocator())
| basic_string (size_type __n, _CharT __c, const _Allocator &__a=_Allocator())
| basic_string (std::initializer_list< _CharT > __l, const _Allocator &__a=_Allocator())
const _Base & | _M_base () const noexcept
_Base & | _M_base () noexcept
template<typename _Predicate >
void | _M_invalidate_if (_Predicate __pred)
basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | _M_replace_dispatch (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2, __false_type)
template<typename _Predicate >
void | _M_transfer_from_if (_Safe_sequence &__from, _Predicate __pred)
_CharT * | _S_construct (_InIterator __beg, _InIterator __end, const std::allocator< _CharT > &__a, forward_iterator_tag)
template<typename _InputIterator >
basic_string & | append (_InputIterator __first, _InputIterator __last)
basic_string & | append (const _CharT *__s)
basic_string & | append (const _CharT *__s, size_type __n)
_If_sv< _Tp, basic_string & > | append (const _Tp &__svt)
_If_sv< _Tp, basic_string & > | append (const _Tp &__svt, size_type __pos, size_type __n=npos)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | append (const basic_string &__str, size_type __pos, size_type __n=npos)
basic_string & | append (initializer_list< _CharT > __l)
basic_string & | append (size_type __n, _CharT __c)
template<typename _InputIterator >
basic_string & | assign (_InputIterator __first, _InputIterator __last)
basic_string & | assign (basic_string &&__str) noexcept(allocator_traits< std::allocator< _CharT > >::is_always_equal::value)
basic_string & | assign (basic_string &&__x) noexcept(noexcept(std::declval< _Base & >().assign(std::move(__x))))
basic_string & | assign (const _CharT *__s)
basic_string & | assign (const _CharT *__s, size_type __n)
_If_sv< _Tp, basic_string & > | assign (const _Tp &__svt)
_If_sv< _Tp, basic_string & > | assign (const _Tp &__svt, size_type __pos, size_type __n=npos)
basic_string & | assign (const basic_string &__str)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n)
basic_string & | assign (const basic_string &__str, size_type __pos, size_type __n=npos)
basic_string & | assign (const basic_string &__x)
basic_string & | assign (size_type __n, _CharT __c)
basic_string & | assign (std::initializer_list< _CharT > __l)
reference | at (size_type __n)
reference | at (size_type __n)
const_reference | at (size_type __n) const
const_reference | at (size_type __n) const
reference | back ()
const_reference | back () const noexcept
const_reference | back () const noexcept
iterator | begin ()
const_iterator | begin () const noexcept
const _CharT * | c_str () const noexcept
size_type | capacity () const noexcept
size_type | capacity () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
void | clear ()
int | compare (const _CharT *__s) const
_If_sv< _Tp, int > | compare (const _Tp &__svt) const noexcept(is_same< _Tp, __sv_type >::value)
int | compare (const basic_string &__str) const
int | compare (const basic_string &__str) const
_If_sv< _Tp, int > | compare (size_type __pos, size_type __n, const _Tp &__svt) const noexcept(is_same< _Tp, __sv_type >::value)
int | compare (size_type __pos, size_type __n, const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const _CharT *__s) const
int | compare (size_type __pos1, size_type __n1, const _CharT *__s, size_type __n2) const
_If_sv< _Tp, int > | compare (size_type __pos1, size_type __n1, const _Tp &__svt, size_type __pos2, size_type __n2=npos) const noexcept(is_same< _Tp, __sv_type >::value)
int | compare (size_type __pos1, size_type __n1, const basic_string &__str) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2) const
int | compare (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos) const
size_type | copy (_CharT *__s, size_type __n, size_type __pos=0) const
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
const _CharT * | data () const noexcept
_CharT * | data () noexcept
bool | empty () const noexcept
bool | empty () const noexcept
iterator | end ()
const_iterator | end () const noexcept
bool | ends_with (_CharT __x) const noexcept
bool | ends_with (basic_string_view< _CharT, std::char_traits< _CharT > > __x) const noexcept
bool | ends_with (const _CharT *__x) const noexcept
iterator | erase (__const_iterator __first, __const_iterator __last)
iterator | erase (__const_iterator __position)
iterator | erase (iterator __first, iterator __last)
iterator | erase (iterator __position)
basic_string & | erase (size_type __pos=0, size_type __n=_Base::npos)
size_type | find (_CharT __c, size_type __pos=0) const noexcept
size_type | find (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find (const _CharT *__s, size_type __pos=0) const
_If_sv< _Tp, size_type > | find (const _Tp &__svt, size_type __pos=0) const noexcept(is_same< _Tp, __sv_type >::value)
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_not_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_first_not_of (const _CharT *__s, size_type __pos=0) const
_If_sv< _Tp, size_type > | find_first_not_of (const _Tp &__svt, size_type __pos=0) const noexcept(is_same< _Tp, __sv_type >::value)
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_not_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (_CharT __c, size_type __pos=0) const noexcept
size_type | find_first_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_first_of (const _CharT *__s, size_type __pos=0) const
_If_sv< _Tp, size_type > | find_first_of (const _Tp &__svt, size_type __pos=0) const noexcept(is_same< _Tp, __sv_type >::value)
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_first_of (const basic_string &__str, size_type __pos=0) const noexcept
size_type | find_last_not_of (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | find_last_not_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_last_not_of (const _CharT *__s, size_type __pos=_Base::npos) const
_If_sv< _Tp, size_type > | find_last_not_of (const _Tp &__svt, size_type __pos=npos) const noexcept(is_same< _Tp, __sv_type >::value)
size_type | find_last_not_of (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | find_last_not_of (const basic_string &__str, size_type __pos=npos) const noexcept
size_type | find_last_of (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | find_last_of (const _CharT *__s, size_type __pos, size_type __n) const
size_type | find_last_of (const _CharT *__s, size_type __pos=_Base::npos) const
_If_sv< _Tp, size_type > | find_last_of (const _Tp &__svt, size_type __pos=npos) const noexcept(is_same< _Tp, __sv_type >::value)
size_type | find_last_of (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | find_last_of (const basic_string &__str, size_type __pos=npos) const noexcept
reference | front ()
const_reference | front () const noexcept
const_reference | front () const noexcept
allocator_type | get_allocator () const noexcept
allocator_type | get_allocator () const noexcept
iterator | insert (__const_iterator __p, _CharT __c)
template<typename _InputIterator >
iterator | insert (__const_iterator __p, _InputIterator __first, _InputIterator __last)
iterator | insert (const_iterator __p, size_type __n, _CharT __c)
iterator | insert (const_iterator __p, std::initializer_list< _CharT > __l)
iterator | insert (iterator __p, _CharT __c)
void | insert (iterator __p, _InputIterator __beg, _InputIterator __end)
void | insert (iterator __p, initializer_list< _CharT > __l)
void | insert (iterator __p, size_type __n, _CharT __c)
basic_string & | insert (size_type __pos, const _CharT *__s)
basic_string & | insert (size_type __pos, const _CharT *__s, size_type __n)
_If_sv< _Tp, basic_string & > | insert (size_type __pos, const _Tp &__svt)
basic_string & | insert (size_type __pos, size_type __n, _CharT __c)
_If_sv< _Tp, basic_string & > | insert (size_type __pos1, const _Tp &__svt, size_type __pos2, size_type __n=npos)
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n)
basic_string & | insert (size_type __pos1, const basic_string &__str, size_type __pos2, size_type __n=npos)
size_type | length () const noexcept
size_type | length () const noexcept
size_type | max_size () const noexcept
size_type | max_size () const noexcept
| operator __sv_type () const noexcept
basic_string & | operator+= (_CharT __c)
basic_string & | operator+= (const _CharT *__s)
_If_sv< _Tp, basic_string & > | operator+= (const _Tp &__svt)
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (const basic_string &__str)
basic_string & | operator+= (std::initializer_list< _CharT > __l)
basic_string & | operator= (_CharT __c)
basic_string & | operator= (basic_string &&)=default
basic_string & | operator= (const _CharT *__s)
basic_string & | operator= (const basic_string &)=default
basic_string & | operator= (std::initializer_list< _CharT > __l)
reference | operator[] (size_type __pos)
const_reference | operator[] (size_type __pos) const noexcept
void | pop_back ()
void | push_back (_CharT __c)
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const noexcept
reverse_iterator | rend ()
const_reverse_iterator | rend () const noexcept
template<typename _InputIterator >
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, _InputIterator __j1, _InputIterator __j2)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, const basic_string &__str)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, size_type __n, _CharT __c)
basic_string & | replace (__const_iterator __i1, __const_iterator __i2, std::initializer_list< _CharT > __l)
_If_sv< _Tp, basic_string & > | replace (const_iterator __i1, const_iterator __i2, const _Tp &__svt)
basic_string & | replace (iterator __i1, iterator __i2, _CharT *__k1, _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, _InputIterator __k1, _InputIterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__k1, const _CharT *__k2)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s)
basic_string & | replace (iterator __i1, iterator __i2, const _CharT *__s, size_type __n)
basic_string & | replace (iterator __i1, iterator __i2, const basic_string &__str)
basic_string & | replace (iterator __i1, iterator __i2, const_iterator __k1, const_iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, initializer_list< _CharT > __l)
basic_string & | replace (iterator __i1, iterator __i2, iterator __k1, iterator __k2)
basic_string & | replace (iterator __i1, iterator __i2, size_type __n, _CharT __c)
_If_sv< _Tp, basic_string & > | replace (size_type __pos, size_type __n, const _Tp &__svt)
basic_string & | replace (size_type __pos, size_type __n, const basic_string &__str)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s)
basic_string & | replace (size_type __pos, size_type __n1, const _CharT *__s, size_type __n2)
basic_string & | replace (size_type __pos, size_type __n1, size_type __n2, _CharT __c)
_If_sv< _Tp, basic_string & > | replace (size_type __pos1, size_type __n1, const _Tp &__svt, size_type __pos2, size_type __n2=npos)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2)
basic_string & | replace (size_type __pos1, size_type __n1, const basic_string &__str, size_type __pos2, size_type __n2=npos)
void | reserve ()
void | reserve (size_type __res_arg)
void | reserve (size_type __res_arg)
void | resize (size_type __n)
void | resize (size_type __n, _CharT __c)
size_type | rfind (_CharT __c, size_type __pos=_Base::npos) const noexcept
size_type | rfind (const _CharT *__s, size_type __pos, size_type __n) const
size_type | rfind (const _CharT *__s, size_type __pos=_Base::npos) const
_If_sv< _Tp, size_type > | rfind (const _Tp &__svt, size_type __pos=npos) const noexcept(is_same< _Tp, __sv_type >::value)
size_type | rfind (const basic_string &__str, size_type __pos=_Base::npos) const noexcept
size_type | rfind (const basic_string &__str, size_type __pos=npos) const noexcept
void | shrink_to_fit () noexcept
size_type | size () const noexcept
size_type | size () const noexcept
bool | starts_with (_CharT __x) const noexcept
bool | starts_with (basic_string_view< _CharT, std::char_traits< _CharT > > __x) const noexcept
bool | starts_with (const _CharT *__x) const noexcept
basic_string | substr (size_type __pos=0, size_type __n=_Base::npos) const
void | swap (basic_string &__s) noexcept(/*conditional */)
void | swap (basic_string &__x) noexcept(/*conditional */)

## Public Attributes

_Safe_iterator_base * | _M_const_iterators
_Safe_iterator_base * | _M_iterators
unsigned int | _M_version

## Static Public Attributes

static const size_type | npos

## Protected Member Functions

void | _M_detach_all ()
void | _M_detach_singular ()
__gnu_cxx::__mutex & | _M_get_mutex () throw ()
void | _M_invalidate_all () const
void | _M_revalidate_singular ()
void | _M_swap (_Safe_container &__x) noexcept
void | _M_swap (_Safe_sequence_base &__x) noexcept

## Friends

template<typename _ItT , typename _SeqT , typename _CatT >
class | ::__gnu_debug::_Safe_iterator

## Detailed Description

### template<typename _CharT, typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>
class __gnu_debug::basic_string< _CharT, _Traits, _Allocator >

Class std::basic_string with safety/checking/debug instrumentation.

Definition at line 94 of file debug/string.

## Member Function Documentation

## _M_detach_all()

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) |

protected inherited

Detach all iterators, leaving them singular.

Referenced by __gnu_debug::_Safe_sequence_base::~_Safe_sequence_base().

## _M_detach_singular()

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) |

protected inherited

Detach all singular iterators.

Postcondition
  for all iterators i attached to this sequence, i->_M_version == _M_version.

## _M_get_mutex()

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) |
throw | ( |
| ) |  |

protected inherited

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## _M_invalidate_all()

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const

inline protected inherited

Invalidates all iterators.

Definition at line 256 of file safe_base.h.

References __gnu_debug::_Safe_sequence_base::_M_version.

## _M_invalidate_if()

template<typename _Sequence >
template<typename _Predicate >

void __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if | ( | _Predicate | __pred | ) |

inherited

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 37 of file safe_sequence.tcc.

## _M_revalidate_singular()

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) |

protected inherited

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

## _M_swap()

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) |

protected noexcept inherited

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

## _M_transfer_from_if()

template<typename _Sequence >
template<typename _Predicate >

void __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if | ( | _Safe_sequence< _Sequence > & | __from,
|  | _Predicate | __pred
| ) |  |

inherited

Transfers all iterators `x` that reference `from` sequence, are not singular, and for which `__pred(x)` returns `true`. `__pred` will be invoked with the normal iterators nested in the safe ones.

Definition at line 68 of file safe_sequence.tcc.

References std::__addressof(), __gnu_debug::_Safe_sequence_base::_M_const_iterators, __gnu_debug::_Safe_iterator_base::_M_detach_single(), __gnu_debug::_Safe_sequence_base::_M_get_mutex(), __gnu_debug::_Safe_sequence_base::_M_iterators, __gnu_debug::_Safe_iterator_base::_M_next, __gnu_debug::_Safe_iterator_base::_M_prior, __gnu_debug::_Safe_iterator_base::_M_sequence, and __gnu_debug::_Safe_iterator_base::_M_version.

## append() [1/5]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | const _Tp & | __svt | ) |

inline inherited

Append a string_view.

Parameters

  __svt | The object convertible to string_view to be appended.

Returns
  Reference to this string.

Definition at line 1301 of file cow_string.h.

## append() [2/5]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | const _Tp & | __svt,
|  | size_type | __pos,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Append a range of characters from a string_view.

Parameters

  __svt | The object convertible to string_view to be appended from.
  __pos | The position in the string_view to append from.
  __n | The number of characters to append from the string_view.

Returns
  Reference to this string.

Definition at line 1317 of file cow_string.h.

## append() [3/5]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > > & std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) |

inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1219 of file cow_string.h.

## append() [4/5]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > > & std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos,
|  | size_type | __n = `npos`
| ) |  |

inherited

Append a substring.

Parameters

  __str | The string to append.
  __pos | Index of the first character of str to append.
  __n | The number of characters to append.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if __pos is not a valid index.

This function appends __n characters from __str starting at __pos to this string. If __n is is larger than the number of available characters in __str, the remainder of __str is appended.

Definition at line 1235 of file cow_string.h.

## append() [5/5]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::append | ( | initializer_list< _CharT > | __l | ) |

inline inherited

Append an initializer_list of characters.

Parameters

  __l | The initializer_list of characters to append.

Returns
  Reference to this string.

Definition at line 1276 of file cow_string.h.

## assign() [1/5]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > && | __str | ) |

inline noexcept inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

This function sets this string to the exact contents of __str. __str is a valid, but unspecified string.

Definition at line 1358 of file cow_string.h.

## assign() [2/5]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | const _Tp & | __svt | ) |

inline inherited

Set value from a string_view.

Parameters

  __svt | The source object convertible to string_view.

Returns
  Reference to this string.

Definition at line 1459 of file cow_string.h.

## assign() [3/5]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | const _Tp & | __svt,
|  | size_type | __pos,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Set value from a range of characters in a string_view.

Parameters

  __svt | The source object convertible to string_view.
  __pos | The position in the string_view to assign from.
  __n | The number of characters to assign.

Returns
  Reference to this string.

Definition at line 1474 of file cow_string.h.

## assign() [4/5]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > > & std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) |

inherited

Set value to contents of another string.

Parameters

  __str | Source string to use.

Returns
  Reference to this string.

Definition at line 1346 of file cow_string.h.

## assign() [5/5]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::assign | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Set value to a substring of a string.

Parameters

  __str | The string to use.
  __pos | Index of the first character of str.
  __n | Number of characters to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | if pos is not a valid index.

This function sets this string to the substring of __str consisting of __n characters at __pos. If __n is is larger than the number of available characters in __str, the remainder of __str is used.

Definition at line 1380 of file cow_string.h.

## at() [1/4]

reference std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::at | ( | size_type | __n | ) |

inline inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 1102 of file cow_string.h.

## at() [2/4]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Alloc >::at

inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read/write reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails. Success results in unsharing the string.

Definition at line 1102 of file cow_string.h.

## at() [3/4]

const_reference std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::at | ( | size_type | __n | ) | const

inline inherited

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1080 of file cow_string.h.

## at() [4/4]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::at

inline

Provides access to the data contained in the string.

Parameters

  __n | The index of the character to access.

Returns
  Read-only (const) reference to the character.

Exceptions

  std::out_of_range | If n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the string. The function throws out_of_range if the check fails.

Definition at line 1080 of file cow_string.h.

## back() [1/3]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Alloc >::back

inline

Returns a read/write reference to the data at the last element of the string.

Definition at line 1141 of file cow_string.h.

## back() [2/3]

const_reference std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::back | ( |  | ) | const

inline noexcept inherited

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 1152 of file cow_string.h.

## back() [3/3]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::back

inline noexcept

Returns a read-only (constant) reference to the data at the last element of the string.

Definition at line 1152 of file cow_string.h.

## capacity() [1/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::capacity | ( |  | ) | const

inline noexcept inherited

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 969 of file cow_string.h.

## capacity() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::capacity

inline noexcept

Returns the total number of characters that the string can hold before needing to allocate more memory.

Definition at line 969 of file cow_string.h.

## compare() [1/6]

_If_sv<_Tp, int> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | const _Tp & | __svt | ) | const

inline noexcept inherited

Compare to a string_view.

Parameters

  __svt | An object convertible to string_view to compare against.

Returns
  Integer < 0, 0, or > 0.

Definition at line 2782 of file cow_string.h.

## compare() [2/6]

int std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) | const

inline inherited

Compare to a string.

Parameters

  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Returns an integer < 0 if this string is ordered before __str, 0 if their values are equivalent, or > 0 if this string is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of size() and str.size(). The function then compares the two strings by calling traits::compare(data(), str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 2762 of file cow_string.h.

## compare() [3/6]

_If_sv<_Tp, int> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const _Tp & | __svt
| ) |  | const

inline noexcept inherited

Compare to a string_view.

Parameters

  __pos | A position in the string to start comparing from.
  __n | The number of characters to compare.
  __svt | An object convertible to string_view to compare against.

Returns
  Integer < 0, 0, or > 0.

Definition at line 2806 of file cow_string.h.

## compare() [4/6]

int std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  | const

inherited

Compare substring to a string.

Parameters

  __pos | Index of first character of substring.
  __n | Number of characters in substring.
  __str | String to compare against.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n characters starting at __pos. Returns an integer < 0 if the substring is ordered before __str, 0 if their values are equivalent, or > 0 if the substring is ordered after __str. Determines the effective length rlen of the strings to compare as the smallest of the length of the substring and __str.size(). The function then compares the two strings by calling traits::compare(substring.data(),str.data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 2855 of file basic_string.tcc.

## compare() [5/6]

_If_sv<_Tp, int> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const _Tp & | __svt,
|  | size_type | __pos2,
|  | size_type | __n2 = `npos`
| ) |  | const

inline noexcept inherited

Compare to a string_view.

Parameters

  __pos1 | A position in the string to start comparing from.
  __n1 | The number of characters to compare.
  __svt | An object convertible to string_view to compare against.
  __pos2 | A position in the string_view to start comparing from.
  __n2 | The number of characters to compare.

Returns
  Integer < 0, 0, or > 0.

Definition at line 2825 of file cow_string.h.

## compare() [6/6]

int std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::compare | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = `npos`
| ) |  | const

inherited

Compare substring to a substring.

Parameters

  __pos1 | Index of first character of substring.
  __n1 | Number of characters in substring.
  __str | String to compare against.
  __pos2 | Index of first character of substring of str.
  __n2 | Number of characters in substring of str.

Returns
  Integer < 0, 0, or > 0.

Form the substring of this string from the __n1 characters starting at __pos1. Form the substring of __str from the __n2 characters starting at __pos2. Returns an integer < 0 if this substring is ordered before the substring of __str, 0 if their values are equivalent, or > 0 if this substring is ordered after the substring of __str. Determines the effective length rlen of the strings to compare as the smallest of the lengths of the substrings. The function then compares the two strings by calling traits::compare(substring.data(),str.substr(pos2,n2).data(),rlen). If the result of the comparison is nonzero returns it, otherwise the shorter one is ordered first.

Definition at line 2881 of file basic_string.tcc.

## data()

_CharT* std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::data | ( |  | ) |

inline noexcept inherited

Return non-const pointer to contents.

This is a pointer to the character sequence held by the string. Modifying the characters in the sequence is allowed.

Definition at line 2229 of file cow_string.h.

## empty() [1/2]

bool std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::empty | ( |  | ) | const

inline noexcept inherited

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 1026 of file cow_string.h.

## empty() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

bool std::basic_string< _CharT, _Traits, _Alloc >::empty

inline noexcept

Returns true if the string is empty. Equivalent to `*this == ""`.

Definition at line 1026 of file cow_string.h.

## erase() [1/2]

basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::erase | ( | iterator | __first,
|  | iterator | __last
| ) |  |

inherited

Remove a range of characters.

Parameters

  __first | Iterator referencing the first character to remove.
  __last | Iterator referencing the end of the range.

Returns
  Iterator referencing location of first after removal.

Removes the characters in the range [first,last) from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1745 of file cow_string.h.

## erase() [2/2]

iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::erase | ( | iterator | __position | ) |

inline inherited

Remove one character.

Parameters

  __position | Iterator referencing the character to remove.

Returns
  iterator referencing same location after removal.

Removes the character at __position from this string. The value of the string doesn't change if an error is thrown.

Definition at line 1725 of file cow_string.h.

## find() [1/2]

_If_sv<_Tp, size_type> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find | ( | const _Tp & | __svt,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a string_view.

Parameters

  __svt | The object convertible to string_view to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Definition at line 2313 of file cow_string.h.

## find() [2/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of start of first occurrence.

Starting from __pos, searches forward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2270 of file cow_string.h.

## find_first_not_of() [1/2]

_If_sv<_Tp, size_type> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_first_not_of | ( | const _Tp & | __svt,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character not in a string_view.

Parameters

  __svt | An object convertible to string_view containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Definition at line 2640 of file cow_string.h.

## find_first_not_of() [2/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_first_not_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2578 of file cow_string.h.

## find_first_of() [1/2]

_If_sv<_Tp, size_type> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_first_of | ( | const _Tp & | __svt,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character of a string_view.

Parameters

  __svt | An object convertible to string_view containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Definition at line 2475 of file cow_string.h.

## find_first_of() [2/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_first_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `0`
| ) |  | const

inline noexcept inherited

Find position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search from (default 0).

Returns
  Index of first occurrence.

Starting from __pos, searches forward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2411 of file cow_string.h.

## find_last_not_of() [1/2]

_If_sv<_Tp, size_type> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_last_not_of | ( | const _Tp & | __svt,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character not in a string_view.

Parameters

  __svt | An object convertible to string_view containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Definition at line 2722 of file cow_string.h.

## find_last_not_of() [2/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_last_not_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character not in string.

Parameters

  __str | String containing characters to avoid.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for a character not contained in __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2660 of file cow_string.h.

## find_last_of() [1/2]

_If_sv<_Tp, size_type> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_last_of | ( | const _Tp & | __svt,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character of string.

Parameters

  __svt | An object convertible to string_view containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Definition at line 2559 of file cow_string.h.

## find_last_of() [2/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::find_last_of | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a character of string.

Parameters

  __str | String containing characters to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of last occurrence.

Starting from __pos, searches backward for one of the characters of __str within this string. If found, returns the index where it was found. If not found, returns npos.

Definition at line 2495 of file cow_string.h.

## front() [1/3]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

reference std::basic_string< _CharT, _Traits, _Alloc >::front

inline

Returns a read/write reference to the data at the first element of the string.

Definition at line 1119 of file cow_string.h.

## front() [2/3]

const_reference std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::front | ( |  | ) | const

inline noexcept inherited

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 1130 of file cow_string.h.

## front() [3/3]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const_reference std::basic_string< _CharT, _Traits, _Alloc >::front

inline noexcept

Returns a read-only (constant) reference to the data at the first element of the string.

Definition at line 1130 of file cow_string.h.

## get_allocator() [1/2]

allocator_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::get_allocator | ( |  | ) | const

inline noexcept inherited

Return copy of allocator used to construct this string.

Definition at line 2240 of file cow_string.h.

## get_allocator() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

allocator_type std::basic_string< _CharT, _Traits, _Alloc >::get_allocator

inline noexcept

Return copy of allocator used to construct this string.

Definition at line 2240 of file cow_string.h.

## insert() [1/8]

iterator std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | _CharT | __c
| ) |  |

inline inherited

Insert one character.

Parameters

  __p | Iterator referencing position in string to insert at.
  __c | The character to insert.

Returns
  Iterator referencing newly inserted char.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts character __c at position referenced by __p. If adding character causes the length to exceed max_size(), length_error is thrown. If __p is beyond end of string, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1649 of file cow_string.h.

## insert() [2/8]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | _InputIterator | __beg,
|  | _InputIterator | __end
| ) |  |

inline inherited

Insert a range of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __beg | Start of range.
  __end | End of range.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts characters in range [__beg,__end). If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1514 of file cow_string.h.

## insert() [3/8]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | initializer_list< _CharT > | __l
| ) |  |

inline inherited

Insert an initializer_list of characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __l | The initializer_list of characters to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Definition at line 1525 of file cow_string.h.

## insert() [4/8]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | iterator | __p,
|  | size_type | __n,
|  | _CharT | __c
| ) |  |

inline inherited

Insert multiple characters.

Parameters

  __p | Iterator referencing location in string to insert at.
  __n | Number of characters to insert
  __c | The character to insert.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts __n copies of character __c starting at the position referenced by iterator __p. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1497 of file cow_string.h.

## insert() [5/8]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | size_type | __pos,
|  | const _Tp & | __svt
| ) |  |

inline inherited

Insert a string_view.

Parameters

  __pos | Position in string to insert at.
  __svt | The object convertible to string_view to insert.

Returns
  Reference to this string.

Definition at line 1667 of file cow_string.h.

## insert() [6/8]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | size_type | __pos1,
|  | const _Tp & | __svt,
|  | size_type | __pos2,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Insert a string_view.

Parameters

  __pos1 | Position in string to insert at.
  __svt | The object convertible to string_view to insert from.
  __pos2 | Position in string_view to insert from.
  __n | The number of characters to insert.

Returns
  Reference to this string.

Definition at line 1683 of file cow_string.h.

## insert() [7/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  |

inline inherited

Insert value of a string.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Inserts value of __str starting at __pos1. If adding characters causes the length to exceed max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1545 of file cow_string.h.

## insert() [8/8]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::insert | ( | size_type | __pos1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos2,
|  | size_type | __n = `npos`
| ) |  |

inline inherited

Insert a substring.

Parameters

  __pos1 | Position in string to insert at.
  __str | The string to insert.
  __pos2 | Start of characters in str to insert.
  __n | Number of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.
  std::out_of_range | If pos1 > size() or __pos2 > str.size().

Starting at pos1, insert __n character of __str beginning with __pos2. If adding characters causes the length to exceed max_size(), length_error is thrown. If __pos1 is beyond the end of this string or __pos2 is beyond the end of __str, out_of_range is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1567 of file cow_string.h.

## length() [1/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::length | ( |  | ) | const

inline noexcept inherited

Returns the number of characters in the string, not including any null-termination.

Definition at line 919 of file cow_string.h.

## length() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::length

inline noexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 919 of file cow_string.h.

## max_size() [1/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::max_size | ( |  | ) | const

inline noexcept inherited

Returns the size() of the largest possible string.

Definition at line 924 of file cow_string.h.

## max_size() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::max_size

inline noexcept

Returns the size() of the largest possible string.

Definition at line 924 of file cow_string.h.

## operator __sv_type()

std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::operator __sv_type | ( |  | ) | const

inline noexcept inherited

Convert to a string_view.

Returns
  A string_view.

Definition at line 793 of file cow_string.h.

## operator+=() [1/2]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::operator+= | ( | const _Tp & | __svt | ) |

inline inherited

Append a string_view.

Parameters

  __svt | The object convertible to string_view to be appended.

Returns
  Reference to this string.

Definition at line 1209 of file cow_string.h.

## operator+=() [2/2]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::operator+= | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str | ) |

inline inherited

Append a string to this string.

Parameters

  __str | The string to append.

Returns
  Reference to this string.

Definition at line 1166 of file cow_string.h.

## replace() [1/11]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | const_iterator | __i1,
|  | const_iterator | __i2,
|  | const _Tp & | __svt
| ) |  |

inline inherited

Replace range of characters with string_view.

Parameters

  __i1 | An iterator referencing the start position to replace at.
  __i2 | An iterator referencing the end position for the replace.
  __svt | The object convertible to string_view to insert from.

Returns
  Reference to this string.

Definition at line 2095 of file cow_string.h.

## replace() [2/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | _InputIterator | __k1,
|  | _InputIterator | __k2
| ) |  |

inline inherited

Replace range of characters with range.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __k1 | Iterator referencing start of range to insert.
  __k2 | Iterator referencing end of range to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1973 of file cow_string.h.

## replace() [3/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s
| ) |  |

inline inherited

Replace range of characters with C string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1928 of file cow_string.h.

## replace() [4/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const _CharT * | __s,
|  | size_type | __n
| ) |  |

inline inherited

Replace range of characters with C substring.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __s | C string value to insert.
  __n | Number of characters from s to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the first __n characters of __s are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1907 of file cow_string.h.

## replace() [5/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  |

inline inherited

Replace range of characters with string.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __str | String value to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, the value of __str is inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1888 of file cow_string.h.

## replace() [6/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | initializer_list< _CharT > | __l
| ) |  |

inline inherited

Replace range of characters with initializer_list.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __l | The initializer_list of characters to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, characters in the range [__k1,__k2) are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 2042 of file cow_string.h.

## replace() [7/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | iterator | __i1,
|  | iterator | __i2,
|  | size_type | __n,
|  | _CharT | __c
| ) |  |

inline inherited

Replace range of characters with multiple characters.

Parameters

  __i1 | Iterator referencing start of range to replace.
  __i2 | Iterator referencing end of range to replace.
  __n | Number of characters to insert.
  __c | Character to insert.

Returns
  Reference to this string.

Exceptions

  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__i1,__i2). In place, __n copies of __c are inserted. If the length of result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1949 of file cow_string.h.

## replace() [8/11]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const _Tp & | __svt
| ) |  |

inline inherited

Replace range of characters with string_view.

Parameters

  __pos | The position to replace at.
  __n | The number of characters to replace.
  __svt | The object convertible to string_view to insert.

Returns
  Reference to this string.

Definition at line 2057 of file cow_string.h.

## replace() [9/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | size_type | __pos,
|  | size_type | __n,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str
| ) |  |

inline inherited

Replace characters with value from another string.

Parameters

  __pos | Index of first character to replace.
  __n | Number of characters to be replaced.
  __str | String to insert.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If pos is beyond the end of this string.
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos,__pos+__n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1779 of file cow_string.h.

## replace() [10/11]

_If_sv<_Tp, basic_string&> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const _Tp & | __svt,
|  | size_type | __pos2,
|  | size_type | __n2 = `npos`
| ) |  |

inline inherited

Replace range of characters with string_view.

Parameters

  __pos1 | The position to replace at.
  __n1 | The number of characters to replace.
  __svt | The object convertible to string_view to insert from.
  __pos2 | The position in the string_view to insert from.
  __n2 | The number of characters to insert.

Returns
  Reference to this string.

Definition at line 2074 of file cow_string.h.

## replace() [11/11]

basic_string& std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::replace | ( | size_type | __pos1,
|  | size_type | __n1,
|  | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos2,
|  | size_type | __n2 = `npos`
| ) |  |

inline inherited

Replace characters with value from another string.

Parameters

  __pos1 | Index of first character to replace.
  __n1 | Number of characters to be replaced.
  __str | String to insert.
  __pos2 | Index of first character of str to use.
  __n2 | Number of characters from str to use.

Returns
  Reference to this string.

Exceptions

  std::out_of_range | If __pos1 > size() or __pos2 > __str.size().
  std::length_error | If new length exceeds `max_size()`.

Removes the characters in the range [__pos1,__pos1 + n) from this string. In place, the value of __str is inserted. If __pos is beyond end of string, out_of_range is thrown. If the length of the result exceeds max_size(), length_error is thrown. The value of the string doesn't change if an error is thrown.

Definition at line 1801 of file cow_string.h.

## reserve() [1/3]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve

Equivalent to shrink_to_fit().

Definition at line 997 of file cow_string.h.

## reserve() [2/3]

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::reserve | ( | size_type | __res_arg | ) |

inherited

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 990 of file cow_string.h.

## reserve() [3/3]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

void std::basic_string< _CharT, _Traits, _Alloc >::reserve

Attempt to preallocate enough memory for specified number of characters.

Parameters

  __res_arg | Number of characters required.

Exceptions

  std::length_error | If __res_arg exceeds `max_size()`.

This function attempts to reserve enough memory for the string to hold the specified number of characters. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the string length that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of string data.

Definition at line 990 of file cow_string.h.

## rfind() [1/2]

_If_sv<_Tp, size_type> std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::rfind | ( | const _Tp & | __svt,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a string_view.

Parameters

  __svt | The object convertible to string_view to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Definition at line 2391 of file cow_string.h.

## rfind() [2/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::rfind | ( | const basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __str,
|  | size_type | __pos = `npos`
| ) |  | const

inline noexcept inherited

Find last position of a string.

Parameters

  __str | String to locate.
  __pos | Index of character to search back from (default end).

Returns
  Index of start of last occurrence.

Starting from __pos, searches backward for value of __str within this string. If found, returns the index where it begins. If not found, returns npos.

Definition at line 2332 of file cow_string.h.

## size() [1/2]

size_type std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::size | ( |  | ) | const

inline noexcept inherited

Returns the number of characters in the string, not including any null-termination.

Definition at line 913 of file cow_string.h.

## size() [2/2]

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

size_type std::basic_string< _CharT, _Traits, _Alloc >::size

inline noexcept

Returns the number of characters in the string, not including any null-termination.

Definition at line 913 of file cow_string.h.

## swap()

void std::basic_string< _CharT, std::char_traits< _CharT > , std::allocator< _CharT > >::swap | ( | basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > & | __s | ) |

noexcept inherited

Swap contents with another string.

Parameters

  __s | String to swap with.

Exchanges the contents of this string with that of __s in constant time.

Definition at line 2195 of file cow_string.h.

## Member Data Documentation

## _M_const_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators

inherited

The list of constant iterators that reference this container.

Definition at line 197 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## _M_iterators

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators

inherited

The list of mutable iterators that reference this container.

Definition at line 194 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

## _M_version

unsigned int __gnu_debug::_Safe_sequence_base::_M_version

mutable inherited

The container version number. This number may never be 0.

Definition at line 200 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence_base::_M_invalidate_all().

## npos

template<typename _CharT , typename _Traits = std::char_traits<_CharT>, typename _Allocator = std::allocator<_CharT>>

const basic_string< _CharT, _Traits, _Alloc >::size_type std::basic_string< _CharT, _Traits, _Alloc >::npos

static

Value returned by various member functions when they fail.

Definition at line 328 of file cow_string.h.

The documentation for this class was generated from the following file:

- debug/string